#!/usr/bin/env python
import inspect
from ismatch import *
from public import *

@public
def getmembers(object,predicate=None,include="*",exclude=None,_=True,__=True):
    members = []
    module = inspect.getmodule(object)
    ismod = inspect.ismodule(object)
    for name, object in inspect.getmembers(object,predicate):
        if _==False and name.find("_")==0 and name.find("__")!=0:
            continue
        if __==False and name.find("__")==0:
            continue
        if include and not ismatch(name,include): continue
        if exclude and ismatch(name,exclude): continue
        member = (name, object)
        members.append(member)
    return members

if __name__=="__main__":
    import sys
    print(getmembers(sys.modules[__name__]))
    print("")
    for name, object in getmembers(sys.modules[__name__]):
        print(name,object)

